#!/usr/bin/python

# check for problems with in-place manipulations
#
#

import music
import random

drone = 'co4v32d48,c,c,c,c,c,c,c'
nbrPlayers = 9
maxVol = 30000.0 / (nbrPlayers+1)
minPhraseDuration = 96*10  # 40 minimum duration of a repeated phrase, in clicks
maxPhraseDuration = 96*15  # 120 maximum duration
isRandom = 1

riley = ['rd96',
     'cd6,ed90,cd6,ed90,cd6,ed90',
     'cd6,ed42,fd48,ed96',
     'rd48,e,f,e',
     'rd48,e,f,g',
     'ed48,f,g,r',
     'co4d768',
     'rd336,co3d24,c,cd48,rd432',
     'gd576,fd768',
     'bd24,g,rd336',
     'bv48d24,g',
     'fv48d24,g,b,g,b,g',
     'fv63d48,g,bd384,co4d96',
     'bd24,gd72,gd24,f,gd48,rd72,gd312',
     'co4d384,bo3,g,f+',
     'gd24,rd360',
     'gv48d24,b,co4,bo3',
     'bv48d24,co4,bo3,co4,bo3,r',
     'ev48d24,f+,e,f+,ed72,ed24',
     'rd144,gv63o4d144',
     'ev48d24,f+,e,f+,go2d72,eo3d24,f+,e,f+,e',
     'f+d288',
     'ed144,e,e,e,e,f+,g,a,bd48',
     'ed48,f+d144,f+,f+,f+,f+,g,a,bd96',
     'ed48,f+,gd144,g,g,g,g,a,bd48',
     'ed48,f+,g,ad144,a,a,a,a,b',
     'ed48,f+,g,a,bd144,b,b,b,b',
     'ev48d24,f+,e,f+,gd48,ed24,g,f+,e,f+,e',
     'ev48d24,f+,e,f+,ed72,ed24',
     'ed288,g,co4',
     'co4d576',
     'gv48d24,f,g,b,g,b',
     'fv48d24,g,f,g,b,fd312,gd144',
     'gd24,f,rd48',
     'gv48d24,f',
     'fv48d24,g,b,g,b,g,b,g,b,g,rd336,b-v63d96,go4d288,ad48,gd96,bd48,ad144,gd48,ed288,gd48,f+d336,rd240,e,fd576',
     'fv48d24,g,b,g,b,g',
     'fv48d24,g',
     'fv48d24,g,b',
     'bv48d24,g,f,g,b,co4',
     'bv48d24,f',
     'bv48d24,g',
     'co4d384,bo3,a,co4',
     'fv48o4d24,e,f,e,ed48,e,e,fd24,e',
     'fo4d48,ed96,ed48,cd96',
     'do4d96,d,go3',
     'gv48d24,do4,e,d,rd48,go3,r,g,r,g,gd24,do4,e,d',
     'do4d24,e,dd48',
     'gd576,gd384,fd480',
     'fv48d24,g,b-,g,b-,g',
     'fv48d24,g',
     'fv48d24,g,b-',
     'gv48d24,b-',
     'b-v48d24,g']
  
# print music.phrase(riley[0])
# print


def makesong():
  filetracks = [0];
  perf = music.phrase();
  maxlen = 0;
  for p in range(nbrPlayers):
    pp = music.phrase()

    for rphrase in riley:
      if (isRandom):
        phraseDuration = random.randint(minPhraseDuration, maxPhraseDuration)
      else:
        phraseDuration = 96*5
      subp = music.phrase()
      while (subp.length() < phraseDuration):
        subp += music.phrase.fromString(rphrase)
      pp += subp

    if (pp.length() > maxlen):
      maxlen = pp.length()

    pp.setChan(p+2)
    filetracks.append(pp)
    perf |= pp

  # print "maxlen:",maxlen
  dphr = music.phrase()
  while (dphr.length() < maxlen+10*96):
      dphr += music.phrase.fromString(drone)
  perf |= dphr
  filetracks[0] = dphr
  return perf
         
# convert final phrase to CSound
def printsong(perf):
  for i in perf.notes():
      if (i.noteNbr != -1):
          print 'i%d %.4f %.3f %.3f %d' %     \
            (1,                        \
             i.time/192.0 + isRandom*random.uniform(0,0.02) ,                    \
             i.length/192.0,                    \
             i.vol/128.0 + isRandom*random.uniform(0,.1),                 \
             i.noteNbr)

  # end
  print

#import profile
#import pstats
#profile.run('makesong()', 'songprof')
#p = pstats.Stats('songprof')
#p.sort_stats('cumulative').print_stats(10)

perf = makesong()
printsong(perf)