# wheel music - score generator - Jim Bumgardner

import music
import random
import math

cchord= ['c','g','e-','d']
gchord = ['g','b-','d','a']
echord = ['e-','b-','g','f']
achord = ['a-','e-','c','b-']
chords = [cchord,gchord,achord,echord]


# 32 notes per beat, 2 beats per second
beatsPerSecond = 32*2
secsPerQuadrant = 2
totRevolution = secsPerQuadrant*4
devWidth = 0.5
amp = 0.5

perf = music.phrase()

xpos = []
ypos = []

for i in range(beatsPerSecond*totRevolution*4):
  t = i/beatsPerSecond   # time in seconds
  a = (t*2*math.pi)/totRevolution
  cx = 1 + math.sin(a)*amp
  cy = 1 - math.cos(a)*amp
  px = cx + random.gauss(0,devWidth/2)  
  py = cy + random.gauss(0,devWidth/2)  # was cx
  ch = int(px) + 2*int(py)
  if (ch < 0):
    ch = 0
  elif (ch > 3):
    ch = 3
  if (random.randint(0,1) == 0):  # 50 percent tonic
    idx = 0
  elif (random.randint(0,1) == 0):  # 25 percent 5th
    idx = 1
  elif (random.randint(0,1) == 0):  # 12.5 percent 3rd
    idx = 2
  else:
    idx = 3                         # 12.5 percent 2nd
  p = chords[ch][idx]
  o = 2 + (py - int(py)) * 5
  d = 6
  v = 1 + (px - int(px)) * 32
  note = "%so%dd%dv%d" % (p,o,d,v)
  perf += music.phrase.fromString(note)
  xpos.append(px)
  ypos.append(py)

tempo = 192.0

tLength = perf.length()/float(tempo);

def printsong(perf):
  n = 0
  for i in perf.notes():
      if (i.noteNbr != -1):
          t = i.time/float(tempo)
          if (t < 10):
            fade = t/10.0
          elif (t > tLength - 10):
            fade = 1 - (t-(tLength - 10)) / 10.0
          else:
            fade = 1
          if (fade > 0):
            print 'i %d %.4f %.4f %d %d %d %.2f %.2f' %     \
            (1 ,                                \
             t ,                                \
             0.5+random.uniform(0,2.5),         \
             i.vol*fade,                        \
             i.noteNbr,                         \
             random.randint(5,50),              \
             xpos[n],                           \
             ypos[n])

      n = n+1
  # end
  print

printsong(perf)
  