#!/usr/local/bin/python

import sys, time
from flickrapi import FlickrAPI

# flickr auth information:
defFlickrAPIKey = "12d9e476f6ad2129db1598d51dbe8c03"  # API key
defFlickrSecret = "cce5b2335facb16b"                  # shared "secret"
defFlickrAuthToken = "25907-1d68f572f3b1efab"

oneHourAgo = time.time() - 60*60
twoHoursAgo = time.time() -  2*60*60
yesterday  = time.time() - 1*24*60*60
twoDaysAgo  = time.time() - 2*24*60*60
lastWeek   = time.time() - 7*24*60*60
lastYear   = time.time() - 365*24*60*60
fiveYearsAgo = time.time() - 5*365*24*60*60

groups = [
    dict(name='Squared Circle', id='52242140489@N01', limit=-1, submitWindow=0, cutoffTime=lastWeek, circleCheck=1, autoTag='squaredcircle'),
    dict(name='Fail Sticker', id='1015024@N24', limit=-1, submitWindow=0, cutoffTime=twoDaysAgo, autoTag='failsticker'),
    dict(name='One Letter', id='27034531@N00', limit=-1, submitWindow=0, cutoffTime=twoDaysAgo, autoTag='oneletter'),

    dict(name='One Digit', id='54718308@N00', limit=-1, submitWindow=0, cutoffTime=twoDaysAgo, autoTag='onedigit',
         flickrAPIKey='4066b5400af45a14204d7bb08d19a64d',   # these are the credentials for Gypsy Robot
         flickrSecret='fe84f74e69d4d600', 
         flickrAuthToken='72157614925277933-35d1d96efc6b4ee6')
]

# {name='DC Metro', id='35468135754@N01', limit=3, submitWindow=23*60*60, cutoffTime=$yesterday},
# {name='Add One, Favorite Another', id='28411996@N00', limit=1, submitWindow=23*60*60, cutoffTime=$yesterday},
# {name='Look at Me', id='45631558@N00', limit=1, submitWindow=23*60*60, cutoffTime=$yesterday},
# {name='Canon DSLR', id='35034359018@N01', limit=3, submitWindow=18*60*60, cutoffTime=$yesterday},
# {name='123Pets',  id='82368423@N00', limit=1, submitWindow=12*60*60, cutoffTime => $yesterday},
# {name='Flickys',  id='77342226@N00', limit=3, submitWindow=12*60*60, cutoffTime => $yesterday},


# okay to add tags and delete photos (otherwise, just testing)
doWrites = 1


for group in groups:
    photos = []
    nbrPages = 0
    photoIdx = 0
    print group['name'] + '...'
    
    if group.get('flickrAPIKey'):
      flickrAPIKey = group['flickrAPIKey']
      flickrSecret = group['flickrSecret']
      flickrAuthToken = group['flickrAuthToken']
    else:
      flickrAPIKey = defFlickrAPIKey
      flickrSecret = defFlickrSecret
      flickrAuthToken = defFlickrAuthToken
    
    fapi = FlickrAPI(flickrAPIKey, flickrSecret)

    while True:
        nbrAdded = 0
        groupParms = dict(api_key=flickrAPIKey,
                          group_id=group['id'],
                          per_page='100', 
                          page=str(nbrPages+1), 
                          auth_token=flickrAuthToken)
        if group.get('onlyTagged'):
            groupParms['tags'] = group['onlyTagged']
        rsp = fapi.groups_pools_getPhotos(**groupParms)
        # print repr(rsp)
        if rsp['stat'] == "fail":
            print fapi.getPrintableError(rsp)
            break
        # need to figure out how to skip if there are no photos...
        # print repr(rsp.photos[0].attrib)
        maxTime = 0
        photoList = rsp.photos[0]
        if int(photoList.attrib['page']) > int(photoList.attrib['pages']):
            break
        for photo in photoList.photo:
            id = photo['id']
            # print id
            if int(photo['dateadded']) > int(group['cutoffTime']):
                # print "Recent %s > %s" % (time.ctime(float(photo['dateadded'])), time.ctime(group['cutoffTime']))
                photo['sTime'] = time.ctime(float(photo['dateadded']))
                photos.append(photo)
                nbrAdded += 1
            if int(photo['dateadded']) > maxTime:
                maxTime = int(photo['dateadded'])
            photoIdx += 1
        print "%s..." % (photoIdx)
        nbrPages += 1
        if nbrAdded == 0 or maxTime <= int(group['cutoffTime']):
            break
    print "Collected %d photos" % (len(photos))
    rejects = []
    rejectIDs = {}
    owners = {}
    photos.sort(cmp=lambda a,b: int(a['dateadded']) - int(b['dateadded']),  \
                reverse=bool(group.get('keepNewest')) )

    for photo in photos:
        owner = photo['owner']
        if not owners.has_key(owner):
            owners[owner] = dict(photos=[])
        owners[owner]['photos'].append(photo)

    # perform limit check
    #
    print "%d owners" % (len(owners))
    for ownid in owners:
        # print ownid
        photoList = owners[ownid]['photos']
        n = 0
        for photo in photoList:
            if group['limit'] != -1 and  \
                n >= group['limit'] and int(photo['dateadded']) > int(group['cutoffTime']) and    \
                (not group.has_key('submitWindow') or    \
                abs(int(photo['dateadded']) - int(photoList[n-group['limit']]['dateadded'])) < int(group['submitWindow'])):
                    photo['reason'] = 'past limit';
                    rejectIDs[photo['id']] = 1
                    rejects.append(photo)
            n += 1
    print "%d rejects by limit" % (len(rejects))
    
        
    if group.get('circleCheck'):
        print "Checking sizes"
        circleRejects = 0
        for photo in photos:
            if int(photo['dateadded']) < int(group['cutoffTime']):
                continue
            try:
              rsp = fapi.photos_getSizes(api_key=flickrAPIKey,auth_token=flickrAuthToken, photo_id=photo['id'])
            except:
              print "Unexpected error in fapi.photos_getSizes:", sys.exc_info()[0]
              continue;
            if rsp['stat'] != "fail":
                # sizes = rsp.sizes.size
                # this is an XML node instance... 
                sizes = rsp.sizes[0].size
                # sizes is list of dictionaries, each with the key 'label' - we want to convert
                # to a dictionary of dictionaries, using 'label' as the key
                sizeDict = {}
                for size in sizes:
                    sizeDict[size['label']] = size
                #print repr(sizeDict.keys())
                #print repr(sizeDict.get('Original').attrib.keys())
                if sizeDict.get('Original') and sizeDict.get('Original').attrib.get('width'):
                    dims = sizeDict.get('Original').attrib
                elif sizeDict.get('Large') and sizeDict.get('Large').attrib.get('width'):
                    dims = sizeDict.get('Large').attrib
                elif sizeDict.get('Medium') and sizeDict.get('Medium').attrib.get('width'):
                    dims = sizeDict.get('Medium').attrib
                elif sizeDict.get('Small') and sizeDict.get('Small').attrib.get('width'):
                    dims = sizeDict.get('Small').attrib
                else:
                    dims = sizeDict.get('Thumbnail').attrib
                photo['w'] = int(dims['width'])  
                photo['h'] = int(dims['height'])
                # print "Size of photo %s is %d x %d" % (photo['id'], photo['w'], photo['h'])
                if photo['w'] > 0 and (photo['w'] < 500 or photo['h'] < 500 or abs(float(photo['w'])/photo['h']-1) >= 0.03):
                    tags = ''
                    if abs(float(photo['w'])/photo['h']-1) >= 0.03:
                        photo['reason'] = 'unsquare';
                        tags = tags + 'hipbot:unsquare'
                    elif photo['w'] < 500 or photo['h'] < 500:
                        photo['reason'] = 'too small';
                        tags = tags + 'hipbot:toosmall'
                    rejectIDs[photo['id']] = 1
                    rejects.append(photo)
                    circleRejects += 1
                    print "Adding tags " + tags + " to photo " + photo['id']
                    if doWrites:
                        rsp = fapi.photos_addTags(api_key=flickrAPIKey,auth_token=flickrAuthToken, photo_id=photo['id'], tags=tags)
                        if rsp['stat'] == "fail":
                            print "Error adding tags: " + fapi.getPrintableError(rsp)
            else:
                print "Can't get size for photo " + photo['id']

        # reject photos with amazingcircle tag
        print "checking amazing circles"
        rsp = fapi.groups_pools_getPhotos(api_key=flickrAPIKey,group_id=group['id'],   \
                    per_page='100', page=str(nbrPages+1), auth_token=flickrAuthToken, tags='amazingcircle')
        if hasattr(rsp,"photos") and hasattr(rsp.photos[0], "photo"):
            photoList = rsp.photos[0]
            maxTime = 0
            for photo in photoList.photo:
                photo['reason'] = 'amazingcircle tag';
                rejectIDs[photo['id']] = 1
                rejects.append(photo)
                circleRejects += 1
    
    # end of circle check
                
    if group.get('autoTag'):
        print "Checking for tag %s" % (group['autoTag'])
        isTagged = {}
        nbrPages = 0
        hadError = 0
        while True:
            nbrAdded = 0
            rsp = fapi.groups_pools_getPhotos(api_key=flickrAPIKey,group_id=group['id'],   \
                per_page='100', page=str(nbrPages+1), auth_token=flickrAuthToken, tags=group['autoTag'])
            if rsp['stat'] == "fail":
                print "Error searching for %s tags: %s" % (group['autoTag'], fapi.getPrintableError(rsp))
                hadError = 1
            if hasattr(rsp,"photos"):
                photoList = rsp.photos[0]
                maxTime = 0
                if photoList.attrib['page'] > photoList.attrib['pages']:
                    break
                for photo in photoList.photo:
                    isTagged[photo['id']] = 1
                if int(photo['dateadded']) > int(group['cutoffTime']):
                    nbrAdded += 1
                    if int(photo['dateadded']) > maxTime:
                        maxTime = int(photo['dateadded'])
                nbrPages += 1
                if nbrAdded == 0 or maxTime <= int(group['cutoffTime']):
                    break
            else:
                hadError = 1
                break
        # end while loop
        if not hadError:
            print "%d tagged photos found" % (len(isTagged))
            for photo in photos:
                # only tag unrejected photos
                if rejectIDs.get(photo['id']):
                    continue
                if isTagged.get(photo['id']):
                    continue
                print "Adding %s tag to photo %s" % (group['autoTag'], photo['id'])
                if doWrites:
                    rsp = fapi.photos_addTags(api_key=flickrAPIKey,auth_token=flickrAuthToken, photo_id=photo['id'], tags=group['autoTag'])
                    if rsp['stat'] == "fail":
                        print "Error adding %s tag: %s" % (group['autoTag'], fapi.getPrintableError(rsp))


    # reject the photos in rejects
    totRejected = 0
    totGroup = len(photos)
    print "%d to reject..." % (len(rejects))
    for photo in rejects:
        print "Rejecting %s by %s submitted at %s... reason: %s" % (photo['id'], photo['owner'], photo['sTime'], photo['reason'])
        if doWrites:
            rsp = fapi.groups_pools_remove(api_key=flickrAPIKey,
                                           auth_token=flickrAuthToken, 
                                           group_id=group['id'],
                                           photo_id=photo['id'])
            if rsp['stat'] == "fail":
                print "Error rejecting %s: %s" % (photo['id'], fapi.getPrintableError(rsp))
            else:
                totRejected += 1
    # end loop
    print "%d rejected of %d for group %s" % (totRejected, totGroup, group['name'])
# end group loop

# end of code


