#!/usr/bin/perl
#  

my @matches = (
{mat=>'killersudoku', nom=>'Killer%20Sudoku',cnt=>0},
{mat=>'dailysudoku', nom=>'Daily%20Sudoku',cnt=>0},
{mat=>'sudoku', nom=>'Sudoku',cnt=>0},
{mat=>'slitherlink', nom=>'Slitherlink',cnt=>0},
{mat=>'kakuro', nom=>'Kakuro',cnt=>0},
{mat=>'krypto', nom=>'Krypto%20Kakuro',cnt=>0},
{mat=>'mazes', nom=>'Mazes',cnt=>0},
{mat=>'jigoku', nom=>'Jigoku',cnt=>0},
{mat=>'kidoku', nom=>'Kidoku',cnt=>0}
);

my %robots = ();

open(IFILE, "../../logs/krazydad.com/http/access.log");

while (<IFILE>)
{
    ($host,$rfc931,$user,$date,$request,$URL,$status,$bytes,$referer,$browser) = /^(\S+) (\S+) (\S+) \[([^]]+)\] "(\w+) (\S+).*" (\d+) (\S+) "([^"]*)" "([^"]*)"/;


    if ($URL eq '/robots.txt') {
      $robots{$host} = $browser;
    }
    next if defined $robots{$host};
	
	  foreach my $mat (@matches) 
	  {
	    if ($URL =~ m~\/$mat->{mat}\/?$~)
	    {
	      $mat->{cnt}++;
	    }
	  }
}	  
close IFILE;

$totCnt = 0;
foreach my $mat (@matches)
{
  $totCnt += $mat->{cnt};
}

# <img src="http://chart.apis.google.com/chart?
# chtt=Puzzle%20popularity%20at%20Krazydad&
# cht=p3&chco=0000FF,FF0000&
# chd=t:53,14,10,8,7,4,2,2,1&
# chs=500x200&
# chl=Sudoku|Kakuro|Daily%20Sudoku|Slitherlink|Mazes|Killer%20Sudoku|Jigoku|Krypto%20Kakuro|Kidoku" />

my $chtt = 'Current Puzzle Popularity%20at%20Krazydad';
my $cht = 'p3';
my $chs = '500x200';
my $chco = '';
my $chd = 't:';
my $chl = '';

my $n = 0;
foreach my $mat (sort {$b->{cnt} <=> $a->{cnt}} @matches)
{
  # printf "%d %s\n", $mat->{cnt}, $mat->{nom};
  $chd .= ($n > 0? ',' : '') . sprintf '%d', $mat->{cnt}*100/$totCnt;
  $chl .= ($n > 0? '|' : '') . $mat->{nom};
  $chco .= ($n > 0? ',' : '') . getColor($n / scalar(@matches));
  $n++;
}

# !! PUT IT TOGETHER...
print "<img src=\"http://chart.apis.google.com/chart?chtt=$chtt&cht=$cht&chco=$chco&chd=$chd&chs=$chs&chl=$chl\" />\n";

sub getColor($)
{
  my ($ratio) = @_;
  my $a = $ratio * 2 * 3.14159;
  my $r = int(sin($a)*127+128);
  my $g = int(sin($a+2)*127+128);
  my $b = int(sin($a+4)*127+128);
  return sprintf '%02x%02x%02x', $r, $g, $b;
}
